

Function Drawall()	'draws everything set to "visible"
	
	DrawConstraints()
	DrawVerlets()
	DrawPolysegs()
	UpdatePhysicsImage()
	
End Function

Function DrawPolysegs()	'draws polygon segments
	
	SetAlpha 1
	SetColor 255,255,255
	SetBlend alphablend
	SetScale 1,1
	SetRotation 0
	
	For Local pcnt:Int = 0 To polysegcount - 1
		Local p:polyseg = polysegarray[pcnt]
		DrawLinescl (p.x1+physicsoffsetx),(p.y1+physicsoffsety),(p.x2+physicsoffsetx),(p.y2+physicsoffsety)
	Next
	
End Function

Function DrawVerlets()	'draws the verlets
	For Local vcnt:Int = 0 To verlcount-1
		Local v:verlet = verletarray:verlet[vcnt]
		If v.hidden Then
			SetAlpha v.alph
			SetBlend v.blendmode
			SetRotation v.angle
			SetScale v.sclx*physicsscalex,v.scly*physicsscaley
			SetColor v.r,v.g,v.b
			If v.image Then
				DrawImage2(v.image,((v.x+physicsoffsetx-physicsoriginx)*physicsscalex)+physicsoriginx,((v.y+physicsoffsety-physicsoriginy)*physicsscaley)+physicsoriginy)
			Else
				SetScale 1,1
				DrawCircle( ((v.x+physicsoffsetx-physicsoriginx)*physicsscalex)+physicsoriginx, ((v.y+physicsoffsety-physicsoriginy)*physicsscaley)+physicsoriginy, v.siz*physicsscalex, v.siz*physicsscaley)
			EndIf
		EndIf
	Next
	SetScale 1,1
	SetAlpha 1
	SetBlend alphablend
	SetRotation 0
	SetColor 255,255,255
End Function

Function drawcircle(x:Int,y:Int,radiusx:Int,radiusy:Int)	'draws a circle
	
	If x > -radiusx And x < GraphicsWidth()+radiusx And y > -radiusy And y < GraphicsHeight()+radiusy Then
		Drawoval x-radiusx,y-radiusy,radiusx*2,radiusy*2
	EndIf
	
End Function

Function DrawConstraints()	'draws constraints
	
	SetAlpha 1
	SetColor 255,255,255
	SetBlend alphablend
	SetScale 1,1
	SetRotation 0
	
	For Local ccnt:Int = 0 To constcount - 1
		Local c:constraint = constraintarray:constraint[ccnt]
		If Not c.hidden Then
			DrawLinescl c.v1.x+physicsoffsetx,c.v1.y+physicsoffsety,c.v2.x+physicsoffsetx,c.v2.y+physicsoffsety
		EndIf
	Next
	
End Function


Function drawlinescl(x1:Int,y1:Int,x2:Int,y2:Int)	'draws a scaled line

DrawLine ((x1-physicsoriginx)*physicsscalex)+physicsoriginx,((y1-physicsoriginy)*physicsscaley)+physicsoriginy,((x2-physicsoriginx)*physicsscalex)+physicsoriginx,((y2-physicsoriginy)*physicsscaley)+physicsoriginy

End Function
